import { Config } from '../types';
export default abstract class CanvasEffect<TConfig extends Config> {
    protected config: TConfig;
    protected canvas: HTMLCanvasElement;
    protected ctx: CanvasRenderingContext2D | null;
    private requestId;
    private delay;
    private fps;
    private timer?;
    constructor(item: HTMLCanvasElement, config: TConfig);
    protected init(): void;
    updateConfig(config: TConfig): void;
    protected abstract render(): void;
    protected clear(): void;
    private main;
    private resize;
    private setCanvasSize;
    private debounce;
}
