"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var requestAnimationFrame_1 = require("./requestAnimationFrame");
var validate = __importStar(require("./validate"));
var CanvasEffect = /** @class */ (function () {
    function CanvasEffect(item, config) {
        this.config = config;
        this.canvas = item;
        this.ctx = item.getContext('2d');
        this.delay = 200;
        this.fps = 60;
        this.setCanvasSize();
    }
    CanvasEffect.prototype.init = function () {
        if (!this.requestId) {
            this.main();
        }
    };
    CanvasEffect.prototype.updateConfig = function (config) {
        if (config.width && (config.width === Infinity || validate.number(config.width))) {
            this.config.width = config.width;
        }
        if (config.height && (config.height === Infinity || validate.number(config.height))) {
            this.config.height = config.height;
        }
    };
    CanvasEffect.prototype.clear = function () {
        if (this.ctx != null) {
            this.ctx.clearRect(0, 0, this.canvas.width, this.canvas.height);
        }
    };
    CanvasEffect.prototype.main = function () {
        this.requestId = (0, requestAnimationFrame_1.requestAnimFrame)(this.main.bind(this), this.fps);
        this.render();
    };
    CanvasEffect.prototype.resize = function () {
        this.setCanvasSize();
        this.init();
    };
    CanvasEffect.prototype.setCanvasSize = function () {
        var height = this.config.height;
        var width = this.config.width;
        var listen = false;
        var isMobile = ('ontouchstart' in document.documentElement && /mobi/i.test(navigator.userAgent));
        if (!isMobile && this.canvas.parentElement) {
            if (!isFinite(height)) {
                height = this.canvas.parentElement.clientWidth;
                listen = true;
            }
            if (!isFinite(width)) {
                width = this.canvas.parentElement.clientWidth;
                listen = true;
            }
        }
        if (listen) {
            window.addEventListener('resize', this.debounce.bind(this));
        }
        console.log(height, width);
        this.canvas.height = height;
        this.canvas.width = width;
    };
    CanvasEffect.prototype.debounce = function () {
        if (this.requestId) {
            cancelAnimationFrame(this.requestId);
            this.requestId = undefined;
        }
        if (this.timer != null) {
            window.clearTimeout(this.timer);
        }
        this.timer = window.setTimeout(this.resize.bind(this), this.delay);
        this.clear();
    };
    return CanvasEffect;
}());
exports.default = CanvasEffect;
